/* ----------------------------------------------------------------------- */
/*         Fernando Berzal Galiano       ETS Ingeniera Informtica        */
/* ----------------------------------------------------------------------- */

#include "DB.H"

/* ----------------------------------------------------------------------- */
/*  Acceso a los campos de las fichas: de 1 a CamposBD(bd)                 */
/* ----------------------------------------------------------------------- */

void *Campo (Ficha ficha, int posicion);

void CadenaCampo (Ficha ficha, int campo, char *cadena);

void CadEnum (DataBase BD, int campo, int posicion, char *cadena);

void CadRef  (DataBase BD, int campo, long valor, char *cadena);

/* ----------------------------------------------------------------------- */
/*                     Operaciones bsicas con fichas                      */
/* ----------------------------------------------------------------------- */

long NumeroFicha (Ficha f);

DataBase BDFicha (Ficha f);

/* ----------------------------------------------------------------------- */
/*  Carga una ficha en memoria                                             */

Ficha CargaFicha (DataBase BD, long numero);

/* ----------------------------------------------------------------------- */
/*  Guarda el contenido de una ficha en disco                              */

void GuardaFicha (Ficha f);

/* ----------------------------------------------------------------------- */
/*  Libera la memoria ocupada por una ficha                                */

void LiberaFicha (Ficha *f);

/* ----------------------------------------------------------------------- */
/*  Elimina fsicamente y libera una ficha                                 */

void BorraFicha (Ficha *f);

/* ----------------------------------------------------------------------- */
/*  Crea una ficha "vaca"                                                 */

Ficha CreaFicha (DataBase BD);

/* ----------------------------------------------------------------------- */
