/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */

/* ----------------------------------------------------------------------- */
/*                           Manejo de fechas                              */
/* ----------------------------------------------------------------------- */
/*                   Fecha = ((ao*12)+mes-1)*32+dia                       */
/* ----------------------------------------------------------------------- */

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <time.h>

#include "FBG_CRT.H"
#include "FBG_KBD.H"
#include "FBG_DATE.H"

/* ----------------------------------------------------------------------- */
/*  Manejo de fechas                                                       */
/* ----------------------------------------------------------------------- */

long Hoy (void)  /* Fecha = ((ao*12)+mes-1)*32+dia */
{
  time_t     ahora = time(NULL);
  struct tm *t     = localtime(&ahora);

  return (((t->tm_year+1900)*12L)+t->tm_mon)*32L+t->tm_mday;
}

/* ----------------------------------------------------------------------- */

char *Mes[] = { "enero",
                "febrero",
                "marzo",
                "abril",
                "mayo",
                "junio",
                "julio",
                "agosto",
                "septiembre",
                "octubre",
                "noviembre",
                "diciembre"
               };

int NumDias[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

/* ----- */

int Dias (int mes, int agno)
{
  if ((mes==1)&&(agno%4==0))                  /* Febrero en aos bisiestos */
     return NumDias[mes]+1;
  else
     return NumDias[mes];
}

/* ----- */

void MuestraFecha (int dia, int mes, int agno, int x, int y, int CActivo)
{
  GotoXY (x,y);

  if (CActivo==0) {
     PrintF ("%d de %s de %d", dia, Mes[mes], agno);
  } else if (CActivo==1) {
     TextColor (NEGRO);
     TextBackground (GRIS);
     PrintF ("%d", dia);
     TextColor (GRIS);
     TextBackground (NEGRO);
     PrintF (" de %s de %d", Mes[mes], agno);
  } else if (CActivo==2) {
     PrintF ("%d de ", dia);
     TextColor (NEGRO);
     TextBackground (GRIS);
     PrintF ("%s", Mes[mes]);
     TextColor (GRIS);
     TextBackground (NEGRO);
     PrintF (" de %d", agno);
  } else if (CActivo==3) {
     PrintF ("%d de %s de ", dia, Mes[mes]);
     TextColor (NEGRO);
     TextBackground (GRIS);
     PrintF ("%d", agno);
     TextColor (GRIS);
     TextBackground (NEGRO);
  }

  PrintF ("          ");
}

/* ----- */

int EditaFecha (long *fecha)
{
  int dia  = *fecha % 32;
  int aux  = *fecha >> 5;
  int mes  = aux % 12;        /* mes de 0 a 11 */
  int agno = aux / 12;

  int CampoActivo = 1;  /* 0=ninguno, 1=dia, 2=mes, 3=ao */

  int  tecla;
  BYTE x,y;

  unsigned cursor = EstadoCursor();

  PosicionCursor(&x,&y);

  Cursor (OCULTO);

  do {

      if (!dia)
         dia = 1;
      else if ( dia > Dias (mes,agno) )
         dia = Dias (mes,agno);

      MuestraFecha (dia, mes, agno, x, y, CampoActivo);

      tecla = GetChar();

      if (!tecla) {                             /* Cdigos de control 0 */

         tecla = GetChar();

         switch (tecla) {

           case '\x4B':                                       /* Izquierda */
                        if (CampoActivo>1)
                           CampoActivo--;
                        else
                           CampoActivo = 3;
                        break;

           case '\x4D':                                         /* Derecha */
                        if (CampoActivo<3)
                           CampoActivo++;
                        else
                           CampoActivo = 1;
                        break;

           case '\x48':                                          /* Arriba */
                        switch (CampoActivo) {

                          case 1: if (dia<Dias(mes,agno))

                                     dia ++;

                                  else {

                                     dia = 1;

                                     if (mes<11)
                                        mes++;
                                     else {
                                        mes = 0;
                                        agno ++;
                                     }
                                  }

                                  break;

                          case 2: if (mes<11)
                                     mes ++;
                                  else {
                                     mes = 0;
                                     agno ++;
                                  }
                                  break;

                          case 3: agno++;
                                  break;
                        }
                        break;

           case '\x50':                                           /* Abajo */
                        switch (CampoActivo) {

                          case 1: if (dia>1)

                                     dia --;

                                  else {

                                     if (mes>0)
                                        mes--;
                                     else {
                                        mes = 11;
                                        agno--;
                                     }

                                     dia = Dias(mes,agno);

                                  }

                                  break;

                          case 2: if (mes)   /* mes > 0 */
                                     mes --;
                                  else {
                                     mes = 11;
                                     agno --;
                                  }
                                  break;

                          case 3: agno--;
                                  break;

                        }
                        break;
         }
         tecla = 0;

      } else if (isdigit(tecla)) {                 /* Nmero pulsado       */

         switch (CampoActivo) {

           case 1: if (dia*10 + tecla - '0' > Dias (mes, agno))
                      dia = tecla - '0';
                   else
                      dia = dia*10 + tecla - '0';
                   break;

           case 2: if ((mes==0)&&(tecla<'3'))
                      mes = 9 + tecla - '0';
                   else if (tecla!='0')
                      mes = tecla - '1';
                   break;

           case 3: if (agno<1000)
                      agno = agno*10 + tecla - '0';
                   else
                      agno = 10*(agno/10) + tecla - '0';
                   break;
         }

      } else if (tecla==DEL) {

         if (CampoActivo==1)
            dia = dia / 10;
         else if (CampoActivo==3)
            agno = agno / 10;
      }

  } while (tecla!=RETURN && tecla!=ESCAPE);

  Cursor (cursor);
  MuestraFecha (dia, mes, agno, x, y, 0);

  if (tecla!=ESCAPE)
     *fecha = (agno*12L+mes)*32L+dia;

  return tecla;
}

/* ----------------------------------------------------------------------- */

void CadenaFecha (char *cad, long fecha)
{
  int year, mes, dia;
  char cadaux[10];

  dia   = fecha % 32;
  fecha = fecha >> 5;
  mes   = fecha % 12;
  year  = fecha / 12;

  itoa (dia, cad, 10);
  strcat (cad, " de ");
  strcat (cad, Mes[mes]);
  strcat (cad, " de ");
  itoa (year, cadaux, 10);
  strcat (cad, cadaux);
}

/* ----------------------------------------------------------------------- */
