/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                               Teclado                                   */
/* ----------------------------------------------------------------------- */

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef WORD
#define WORD unsigned short
#endif

/* ----------------------------------------------------------------------- */

#ifndef __FBG_KBD__
#define __FBG_KBD__

/* ----------------------------------------------------------------------- */

/* Teclas especiales */

#define RETURN 0x0D
#define ESCAPE 0x1B
#define DEL    0x08

#define CR     13
#define LF     10
#define FF     12

/* ----------------------------------------------------------------------- */

BYTE GetChar (void);

/* ----------------------------------------------------------------------- */

int TeclaPulsada (void);

/* ----------------------------------------------------------------------- */

int Shift      (void);
int LeftShift  (void);
int RightShift (void);

int Control      (void);
int LeftControl  (void);
int RightControl (void);

int Alt      (void);
int LeftAlt  (void);
int RightAlt (void);

/* ----------------------------------------------------------------------- */

int ScrollLock (void);
int NumLock    (void);
int CapsLock   (void);

/* ----------------------------------------------------------------------- */

#define CAPS_LOCK    64
#define NUM_LOCK     32
#define SCROLL_LOCK  16

void SetLED   (BYTE flag);
void ClearLED (BYTE flag);

/* ----------------------------------------------------------------------- */

void AnulaBufferTeclado (void);

/* ----------------------------------------------------------------------- */

#endif
