/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                      Pantalla: Modo de vdeo 03h                        */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*                       Captura perfecta de datos                         */
/* ----------------------------------------------------------------------- */
/*                              T E X T O S                                */
/* ----------------------------------------------------------------------- */

#include <string.h>
#include <stdlib.h>

#include "FBG_CRT.H"
#include "FBG_KBD.H"
#include "FBG_TEXT.H"


/*------------------------------------------------------------------------*/
/*                               Cadenas                                  */
/*------------------------------------------------------------------------*/

char *Borra (char *cadena, int Posicion)
{
  char *aux = malloc(strlen(cadena));
  int   i;

  if (aux) {

     for (i=0; i<Posicion; i++)
	 aux[i]=cadena[i];

     for (i=Posicion; i<strlen(cadena); i++)
	 aux[i]=cadena[i+1];

  }

  return aux;
}

char *Inserta (char *cadena, int Posicion, char Ch)
{
  int   x;
  int   l   = (cadena)? strlen(cadena)+2: 2;
  char *aux = malloc (l);

  if (cadena) {

     for  (x=0; x<Posicion; x++)
	  aux[x] = cadena[x];

     aux[Posicion] = Ch;

     for (x=Posicion; x<=strlen(cadena); x++)
	 aux[x+1] = cadena[x];

  } else {
     aux[0] = Ch;
     aux[1] = '\0';
  }

  return aux;
}


char *Izquierda (char *cadena, int Posicion)
{
  int   x;
  char *aux = malloc (Posicion+1);

  for (x=0; x<Posicion; x++)
      aux[x] = cadena[x];

  aux[Posicion] = '\0';

  return aux;
}

char *Derecha (char *cadena, int Posicion)
{
  int   x;
  char *aux = malloc (strlen(cadena)-Posicion+1);

  for (x=Posicion; x<=strlen(cadena); x++)
      aux[x-Posicion] = cadena[x];

  return aux;
}


char *Concatena (char *s1, char *s2)
{
  char *aux = malloc (strlen(s1)+strlen(s2)+1);

  strcpy (aux, s1);
  strcat (aux, s2);

  return aux;
}

/* ----------------------------------------------------------------------- */
/*                       Captura perfecta de datos                         */
/* ----------------------------------------------------------------------- */

/* Dimensiones de la ventana */

BYTE ancho, alto;

/* Posicin actual */

Linea line;

int  X;
int  Y;

/* Texto */

Texto text;
int   NumLineas;
int   Insertar;

/*------------------------------------------------------------------------*/

BYTE  Xpos,Ypos;
int   l;
int   ColumnaInicial;
int   LineaInicial;
char *s;
Linea ptr;
Linea inicio;

/* ----- */

void MuestraTextoCompleto (void)
{
  Cursor (OCULTO);

  if (X-ColumnaInicial>ancho)
     ColumnaInicial = X-ancho;
  else if (X<ColumnaInicial)
     ColumnaInicial = X;

  if (Y-LineaInicial>alto) {
     LineaInicial++;
     inicio = SiguienteLinea (text,inicio);
  } else if (Y<LineaInicial) {
     LineaInicial--;
     inicio = AnteriorLinea (text, inicio);
  }

  ptr = inicio;
  
  for ( Ypos=0; Ypos<=alto; Ypos++) { 
  
      GotoXY (1,1+Ypos);

      if (ptr!=FinTexto(text)) {
	 s = CadenaLinea (text, ptr);
	 l = strlen (s);

	 for (Xpos=ColumnaInicial; Xpos<=ColumnaInicial+ancho; Xpos++) {
	     if (Xpos<l)
		PutChar (s[Xpos]);
	     else
		PutChar (' ');
	 }

	 ptr = SiguienteLinea (text,ptr);

      } else for (Xpos=0; Xpos<=ancho; Xpos++)
		 PutChar (' ');
  }

  GotoXY (X-ColumnaInicial+1, Y-LineaInicial+1);

  if (Insertar)
     Cursor (GRANDE);
  else
     Cursor (VISIBLE);
}

/* ----- */

void MuestraLineaActual (void)
{
  char *LineaActual = CadenaLinea(text,line);

  Cursor (OCULTO);

  GotoXY (1, 1+Y-LineaInicial);

  l = strlen (LineaActual);

  for (Xpos=ColumnaInicial; Xpos<=ColumnaInicial+ancho; Xpos++) {
      if (Xpos<l)
	 PutChar (LineaActual[Xpos]);
      else
	 PutChar (' ');
  }

  GotoXY (X-ColumnaInicial+1, Y-LineaInicial+1);

  if (Insertar)
     Cursor (GRANDE);
  else
     Cursor (VISIBLE);
}

/* ----- */

void MuestraTexto (void)
{
  if ( (X-ColumnaInicial>ancho) || (X<ColumnaInicial) ||
       (Y-LineaInicial  >alto ) || (Y<LineaInicial  ) )
     MuestraTextoCompleto();
  else
     MuestraLineaActual();
}

/* ----- */

void ColocaCursor (void)
{
  if ( (X-ColumnaInicial>ancho) || (X<ColumnaInicial) ||
       (Y-LineaInicial  >alto ) || (Y<LineaInicial  ) )
     MuestraTextoCompleto ();
  else
     GotoXY (X-ColumnaInicial+1, Y-LineaInicial+1);
}

/*------------------------------------------------------------------------*/

void EditaTexto ( Texto txt )
{
  char  Ch;
  char *aux, *aux2;
  int   espacios,lineas;
  BYTE  Xmin,Ymin,Xmax,Ymax;
  WORD  cursor = EstadoCursor();

  text     = txt;
  Insertar = 0;

  cls ();

  VentanaActual(&Xmin,&Ymin,&Xmax,&Ymax);

  ancho = Xmax-Xmin-1;        /* La ltima columna de la ventana no se usa */
  alto  = Ymax-Ymin;

  X     = 0;
  Y     = 1;

  for ( line=PrimeraLinea(text), NumLineas=0;
	line!=FinLista(text);
	line=SiguienteLinea(text,line) )
      NumLineas++;


  if (NumLineas==0) {
     AgregaLinea (text, "");
     NumLineas   = 1;
  }

  Cursor ( VISIBLE );

  /* Visualizacin */

  line  = PrimeraLinea (text);
  inicio = PrimeraLinea (text);

  ColumnaInicial = 0;
  LineaInicial   = 1;

  MuestraTextoCompleto ();

  /* Bucle principal */

  do {
       Ch = GetChar();

       if ( Ch != ESCAPE )

	  switch (Ch) {

	     case '\0':                              /* Cdigos de control */
			 Ch = GetChar();

			 switch (Ch) {

			   case '\x47':                          /* Inicio */
					X = 0 ;
					ColocaCursor ();
					break;

			   case '\x48':                          /* Arriba */
					if ( line != PrimeraLinea(text) ) {

					   line = AnteriorLinea (text,line);
					   Y--;

					   if (X>strlen(CadenaLinea(text,line)))
					      X = strlen(CadenaLinea(text,line));

					   ColocaCursor ();
					}
					break;

			   case '\x49':                   /* Pgina arriba */
					if (Y-alto>1) {
					   for (lineas=0; lineas<alto; lineas++) {
					       line = AnteriorLinea(text,line);
					       if (LineaInicial==Y) {
						  inicio = AnteriorLinea(text,inicio);
						  LineaInicial--;
					       }
					       Y--;
					   }
					} else {
					   Y = 1;
					   LineaInicial = 1;
					   line = PrimeraLinea(text);
					   inicio = PrimeraLinea(text);
					}

					if (X>strlen(CadenaLinea(text,line)))
					   X=strlen(CadenaLinea(text,line));

					MuestraTextoCompleto();
					break;

			   case '\x4B':                /* Retrocede Cursor */
					if ( X > 0 ) {
					   X --;
					   ColocaCursor ();
					} else if (Y>1) {
					   line = AnteriorLinea(text,line);
					   X = strlen(CadenaLinea(text,line));
					   Y --;
					   ColocaCursor ();
					}
					break;

			   case '\x4D':                   /* Avanza Cursor */
					if ( X < strlen(CadenaLinea(text,line)) ) {
					   X++;
					   ColocaCursor ();
					} else if (Y<NumLineas) {
					   line = SiguienteLinea(text,line);
					   X = 0;
					   Y ++;
					   ColocaCursor ();
					}
					break;

			   case '\x4F':                             /* Fin */
					X = strlen (CadenaLinea(text,line));
					ColocaCursor ();
					break;

			   case '\x50':                           /* Abajo */
					if ( line != UltimaLinea (text) ) {

					   line = SiguienteLinea (text, line);
					   Y++;

					   if (X>strlen(CadenaLinea(text,line)))
					      X=strlen(CadenaLinea(text,line));

					   ColocaCursor ();
					}
					break;

			   case '\x51':                    /* Pgina abajo */
					if (Y+alto<NumLineas) {
					   for (lineas=0; lineas<alto; lineas++) {
					       line = SiguienteLinea(text,line);
					       inicio = SiguienteLinea(text,inicio);
					   }
					   Y += alto;
					   LineaInicial += alto;
					} else {
					   Y = NumLineas;
					   LineaInicial = NumLineas;
					   line = UltimaLinea(text);
					   inicio = UltimaLinea(text);
					}

					if (X>strlen(CadenaLinea(text,line)))
					   X=strlen(CadenaLinea(text,line));

					MuestraTextoCompleto();
					break;

			   case '\x52':                   /* Modo Insertar */
					if (Insertar) {
					   Insertar = 0;
					   Cursor ( VISIBLE );
					} else {
					   Insertar = 1;
					   Cursor ( GRANDE );
					}
					break;

			   case '\x53':                            /* Supr */
					if ( X < strlen(CadenaLinea(text,line)) ) {

					   aux = Borra (CadenaLinea(text,line), X);
					   BorraLinea(text,line);
					   InsertaLinea(text,line,aux);
					   free(aux);
					   MuestraTexto ();

					} else if (Y<NumLineas) {

					   aux = Concatena (CadenaLinea(text,line),
							    CadenaLinea(text,SiguienteLinea(text,line)) );
					   BorraLinea (text,line);
					   BorraLinea (text,line);
					   InsertaLinea (text, line, aux);
					   free(aux);
					   NumLineas--;
					   MuestraTextoCompleto ();
					}
					break;

			 }    /* Switch interno para cdigos \0 de control */

			 break;

		       /* ------------------------------------------------ */

	     case DEL:                                        /* Backspace */
		       if ( X > 0 ) {
			  X--;
			  aux = Borra (CadenaLinea(text,line), X);
			  BorraLinea(text,line);
			  InsertaLinea(text,line,aux);
			  free(aux);
			  MuestraTexto ();
		       } else if (Y>1) {
			  line = AnteriorLista(text,line);
			  X     = strlen (CadenaLinea(text,line));
			  aux   = Concatena( CadenaLinea(text,line),
					     CadenaLinea(text,SiguienteLinea(text,line)) );
			  BorraLinea (text, line);
			  BorraLinea (text, line);
			  InsertaLinea (text, line, aux);
			  free(aux);
			  NumLineas--;
			  Y--;
			  MuestraTextoCompleto ();
		       }
		       break;

		       /* ------------------------------------------------ */

	     case RETURN:                              /* Retorno de carro */
			  if (Insertar) {

			     aux   = Izquierda (CadenaLinea(text,line), X);
			     aux2  = Derecha (CadenaLinea(text,line), X);
			     BorraLinea (text,line);
			     InsertaLinea (text, line, aux);
			     line = SiguienteLista (text, line);
			     InsertaLinea (text, line, aux2);
			     free (aux);
			     free (aux2);
			     NumLineas++;
			     X=0;
			     Y++;
			     MuestraTextoCompleto ();

			  } else {

			     line = SiguienteLista (text, line);

			     if (line==FinTexto(text)) {
				InsertaLinea (text, line, "");
				NumLineas++;
			     }

			     X=0;
			     Y++;
			     MuestraTexto ();
			  }

			  break;


	     case '\t': if (Insertar || X==strlen(CadenaLinea(text,line)) ) {

			   for (espacios=0; espacios<8-X%8; espacios++) {
			       aux = Inserta(CadenaLinea(text,line), X, ' ');
			       BorraLinea (text, line);
			       InsertaLinea (text, line, aux);
			       free (aux);
			   }

			   X += 8-X%8;

			   MuestraTexto ();
			}

			break;


	     default:                                 /* Aade un carcter */

			if ( Insertar || X==strlen(CadenaLinea(text,line)) ) {

			    aux = Inserta(CadenaLinea(text,line), X, Ch);
			    BorraLinea (text, line);
			    InsertaLinea (text, line, aux);
			    free (aux);

			 } else {

			    aux    = CadenaLinea(text,line);
			    aux[X] = Ch;

			 }

			 X++;
			 MuestraTexto ();

	  }

  } while ( Ch != ESCAPE ) ;

  Cursor ( cursor );
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

Texto LeeTexto ( void )
{
  Texto text = CreaTexto();

  EditaTexto ( text );

  return text;
}

/* ----------------------------------------------------------------------- */
