/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */

#include <string.h>
#include <stdlib.h>

#include "FBG_CRT.H"
#include "FBG_KBD.H"

#include "FBG_UTIL.H"

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*                       Captura perfecta de datos                         */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void Delete (char *cadena, int Posicion)
{
  int i;

  for (i=Posicion; i<=strlen(cadena)+1; i++)
      cadena[i]=cadena[i+1];
}

/* ----------------------------------------------------------------------- */

BYTE Xcoord,Ycoord,         /* Coordenadas iniciales                       */
     Anchura,Altura;	    /* Dimensiones de la ventana                   */

int  Longitud,		    /* Espacio til disponible en pantalla         */
     Inicio;		    /* Posicin del primer carcter que se muestra */

/* ----------------------------------------------------------------------- */

void MuestraCadena (char *cadena)
{
  unsigned cursor = EstadoCursor();
  int      indice = Inicio;
  int      i      = 0;

  Cursor (OCULTO);
  GotoXY (Xcoord, Ycoord);

  while (i<Longitud && cadena[indice]) {
	PutChar (cadena[indice++]);
	i++;
  }

  while (i<Longitud) {
	PutChar (' ');
	i++;
  }

  Cursor (cursor);
}

/* ----------------------------------------------------------------------- */

void PosicionaCursor (char *cadena, int Posicion)
{

  if (Posicion<Inicio) {

     Inicio = Posicion;
     MuestraCadena (cadena);
     GotoXY (Xcoord, Ycoord);

  } else if (Altura==1) {                     /* Ventana de una sola lnea */

     if (Posicion-Inicio>=Anchura-Xcoord) {
	Inicio = Posicion - Longitud+1;
	MuestraCadena(cadena);
     }

     GotoXY (Xcoord+Posicion-Inicio,Ycoord);

  } else {                                    /* Ventana de varias lneas */

     if (Posicion-Inicio<=Anchura-Xcoord) {

	GotoXY (Xcoord+Posicion-Inicio,Ycoord);

     } else {

	if (Posicion-Inicio>=Longitud) {
	   Inicio = Posicion-Longitud+1;
	   MuestraCadena(cadena);
	}

	GotoXY ( (Posicion-Inicio+Xcoord-1)%Anchura+1,
		 (Posicion-Inicio+Xcoord-1)/Anchura+Ycoord );
     }
  }

}

/*------------------------------------------------------------------------*/
/* Edita una cadena de caracteres de longitud 'Longitud' (incluido \0).    */
/* Admite cursores, backspace, Supr, Inicio, Fin y modo insertar (Insert). */
/* Devuelve el ltimo carcter pulsado (tipo int).                         */

int EditaCadena ( char *cadena, int longitud)
{
  unsigned char Ch;
  BYTE          Xmin,Xmax,Ymin,Ymax;
  int           Insertar, Posicion, i;
  unsigned      cursor = EstadoCursor();

  Cursor ( VISIBLE );

  Insertar = 0 ;
  longitud = longitud-1;  /* Preserva espacio para \0 */

  PosicionCursor (&Xcoord,&Ycoord);
  VentanaActual (&Xmin,&Ymin,&Xmax,&Ymax);

  Anchura  = Xmax-Xmin+1;
  Altura   = Ymax-Ymin+1;
  Inicio   = 0;
  Posicion = 0;

  i = (Anchura-Xcoord+1) + (Altura-1)*Anchura;  /* Tamao de la ventana */

  Longitud = (i-1>longitud)? longitud: i-1;     /* La ltima posicin de */
						/* la ventana no se usa. */

  MuestraCadena (cadena);
  PosicionaCursor (cadena, Posicion);

  do {
       Ch = GetChar();

       if ( (Ch != RETURN) && (Ch != ESCAPE) )
	  switch (Ch) {

	     case '\0':                              /* Cdigos de control */
			 Ch = GetChar();

			 switch (Ch) {

			   case '\x47':                          /* Inicio */
					Posicion = 0 ;
					PosicionaCursor (cadena,Posicion);
					break;

			   case '\x48':                          /* Arriba */
					if ( Posicion >= Anchura )
					   Posicion -= Anchura;
					else
					   Posicion = 0;

					PosicionaCursor(cadena,Posicion);
					break;

			   case '\x4B':                /* Retrocede Cursor */
					if ( Posicion > 0 )
					   Posicion = Posicion - 1 ;

					PosicionaCursor (cadena, Posicion);
					break;

			   case '\x4D':                   /* Avanza Cursor */
					if ( ( Posicion < strlen(cadena) ) && ( Posicion < longitud-1 ) )
					   Posicion = Posicion + 1 ;

					PosicionaCursor (cadena, Posicion);
					break;

			   case '\x4F':                           /* Fin   */
					if ( longitud > strlen(cadena) + 1)
					   Posicion = strlen(cadena);
					else
					   Posicion = longitud - 1;

					PosicionaCursor (cadena, Posicion);
					break;

			   case '\x50':                           /* Abajo */
					if (Posicion+Anchura>=strlen(cadena)) {
					   Posicion = strlen(cadena);
					   if (Posicion==longitud)
					      Posicion--;
					} else
					   Posicion = Posicion+Anchura;

					PosicionaCursor(cadena,Posicion);
					break;

			   case '\x52':                   /* Modo Insertar */
					if (Insertar) {
					   Insertar = 0;
					   Cursor ( VISIBLE );
					} else {
					   Insertar = 1;
					   Cursor ( GRANDE );
					}
					break;

			   case '\x53':                            /* Supr */
					if ( Posicion < strlen(cadena) ) {
					   Delete (cadena, Posicion);
					   MuestraCadena   (cadena);
					   PosicionaCursor (cadena, Posicion);
					}
					break;

			 } /* Switch Ch interno para cdigos \0 de control */

			 break;

			/* ----------------------------------------------- */

	     case DEL:                                        /* Backspace */
			if ( Posicion > 0 ) {
			   Posicion = Posicion - 1;
			   Delete (cadena, Posicion);
			   MuestraCadena (cadena);
			   PosicionaCursor (cadena, Posicion);
			}
			break;

			/* ----------------------------------------------- */

	     default:                                 /* Aade un carcter */
			   if (Insertar)
			      for ( strlen(cadena)<longitud ? (i=strlen(cadena)+1) : (i=longitud-1); i>Posicion; i--)
				  cadena[i]=cadena[i-1];
			   else if (Posicion==strlen(cadena))
				  cadena[Posicion+1]='\0';

			   cadena[Posicion]=Ch;

			   if (Posicion < longitud-1 )
			      Posicion++;

			   MuestraCadena   (cadena);
			   PosicionaCursor (cadena, Posicion);

	  }
  } while ( ( Ch != RETURN ) && ( Ch != ESCAPE ) );

  Cursor ( cursor );
  return Ch;

} /* Procedimiento EditaCadena */

/* ----------------------------------------------------------------------- */

int LeeCadena (char *cadena, int longitud )
{
  /* Lee una cadena de caracteres de longitud 'longitud'               */
  /* Admite cursores,  backspace,  Supr,  Inicio, Fin y modo insertar. */
  /* Usa la funcin EditaCadena.                                       */

  cadena[0] = '\0';
  return EditaCadena ( cadena , longitud );
}

/* ----------------------------------------------------------------------- */

int EditaEntero (long *numero)
{
  BYTE  x, y;
  int   tecla;
  long  entero;
  char  cadena[10];
  char *endptr;

  PosicionCursor(&x,&y);

  do {
      GotoXY (x,y);
      ltoa ( *numero, cadena, 10 );
      tecla  = EditaCadena ( cadena, 10 );
      entero = strtol (cadena, &endptr, 0);
  } while ( *endptr!='\0' );

  if (tecla!=ESCAPE)
     *numero = entero;

  return tecla;
}


int EditaENTERO ( long *numero, int longitud )
{
  BYTE  x, y;
  int   tecla;
  long  entero;
  char  cadena[10];
  char *endptr;

  PosicionCursor(&x,&y);

  longitud++;   /* Espacio para el '\0' */

  do {
      GotoXY (x,y);
      ltoa ( *numero, cadena, 10 );
      tecla  = EditaCadena ( cadena, longitud );
      entero = strtol (cadena, &endptr, 0);
  } while ( *endptr!='\0' );

  if (tecla!=ESCAPE)
     *numero = entero;

  return tecla;
}


/* ----------------------------------------------------------------------- */

int EditaReal (double *numero)
{
  BYTE   x, y;
  int    tecla;
  char   cadena[20];
  char  *endptr;
  double real;

  PosicionCursor(&x,&y);

  do {
      GotoXY (x,y);
      gcvt ( *numero, 10, cadena);
      tecla = EditaCadena (cadena, 20);
      real  = strtod (cadena, &endptr);
  } while ( *endptr != '\0' );

  if (tecla!=ESCAPE)
     *numero = real;

  return tecla;
}


