/* ------------------------------------------------------------- */
/*    Fernando Berzal Galiano       ETS Ingeniera Informtica   */
/* ------------------------------------------------------------- */
/*            TDA Lista doblemente enlazada (genrica)           */
/* ------------------------------------------------------------- */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "FB_list.h"

/* ------------------------------------------------------------ */
/*                           Primitivas                         */
/* ------------------------------------------------------------ */


Lista CreaLista (int size)
{
  Lista l = malloc (sizeof(InfoLista));

  if (l) {
      l->size     = size;
      l->cabecera = malloc (sizeof(InfoNodo));

      if (l->cabecera) {
	 l->cabecera->anterior = l->cabecera->siguiente = l->cabecera;
	 l->cabecera->info     = NULL;
      } else {
	 free (l);
	 l = NULL;
      }
  }

  return (l);
}

/* ------------------------------------------------------------ */

int ListaVacia (Lista l)
{
    return (l->cabecera->anterior  == l->cabecera);
 /* return (l->cabecera->siguiente == l->cabecera); */
}

/* ------------------------------------------------------------ */

Nodo InicioLista (Lista l)
{
  return (l->cabecera);
}

/* ------------------------------------------------------------ */

Nodo UltimoLista (Lista l)
{
  return (l->cabecera->anterior->anterior);
}

/* ------------------------------------------------------------ */

Nodo FinLista (Lista l)
{
  return (l->cabecera->anterior);
}

/* ------------------------------------------------------------ */

void BorraNodoLista (Lista l, Nodo elemento)
{
  Nodo aux = elemento->siguiente;

  if (elemento != FinLista (l) ) {

     elemento->siguiente = elemento->siguiente->siguiente;
     elemento->siguiente->anterior = elemento;

     if ( l->size && aux->info )
	free (aux->info);

     free (aux);
  }
}

/* ------------------------------------------------------------ */

void DestruyeLista (Lista *l)
{
  while (!ListaVacia(*l))
	BorraNodoLista ( *l, InicioLista(*l) );

  free ((*l)->cabecera);
  free (*l);
  *l = NULL;
}

/* ------------------------------------------------------------ */

int InsertaNodoLista (Lista l, Nodo pos, void *dato)
{
  Nodo nuevo = malloc(sizeof(InfoNodo));

  if (nuevo) {

     if (l->size) {

	nuevo->info = malloc(l->size);

	if (nuevo->info) {
	   memcpy (nuevo->info, dato, l->size);
	} else {
	   free (nuevo);
	   nuevo = NULL;
	}

     } else
	nuevo->info = dato;
  }

  if (nuevo) {
     nuevo->siguiente=pos->siguiente;
     nuevo->anterior =pos;
     nuevo->anterior->siguiente=nuevo;
     nuevo->siguiente->anterior=nuevo;
  }

  return (nuevo!=NULL);
}

/* ------------------------------------------------------------ */

void *LeeNodoLista (Lista l, Nodo elemento)
{
  if (elemento != FinLista(l)) {
     return elemento->siguiente->info;
  } else
     return NULL;
}

/* ------------------------------------------------------------ */

Nodo SiguienteLista (Lista l, Nodo elemento)
{
  if (elemento != FinLista(l))
     return (elemento->siguiente);
  else
     return (NULL);
}

/* ------------------------------------------------------------ */

Nodo SiguienteListaCircular (Lista l, Nodo elemento)
{
  if (elemento != UltimoLista(l))
     return (SiguienteLista (l, elemento));
  else
     return (InicioLista(l));
}

/* ------------------------------------------------------------ */

Nodo AnteriorLista (Lista l, Nodo elemento)
{
  if (elemento != InicioLista(l))
     return (elemento->anterior);
  else
     return (NULL);
}

/* ------------------------------------------------------------ */

Nodo AnteriorListaCircular (Lista l, Nodo elemento)
{
  if (elemento != InicioLista(l))
     return (elemento->anterior);
  else
     return (elemento->anterior->anterior);
}

/* ------------------------------------------------------------ */