/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                              TDA Texto                                  */
/* ----------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "FB_TEXT.H"

/* ----------------------------------------------------------------------- */

Texto CreaTexto (void)
{
  return CreaLista(0);
}

/* ----------------------------------------------------------------------- */

void DestruyeTexto (Texto *texto)
{
  Lista l = *texto;
  char *aux;

  while (!ListaVacia(l)) {

    aux = LeeNodoLista(l,InicioLista(l));

    if (aux)
       free (aux);

    BorraNodoLista (l, InicioLista(l));
  }

  DestruyeLista (texto);
}

/* ----------------------------------------------------------------------- */

Linea PrimeraLinea (Texto t)
{
  return InicioLista(t);
}

Linea UltimaLinea (Texto t)
{
  return UltimoLista(t);
}

Linea FinTexto (Texto t)
{
  return FinLista(t);
}

Linea SiguienteLinea (Texto t, Linea l)
{
  return SiguienteLista(t,l);
}

Linea AnteriorLinea (Texto t, Linea l)
{
  return AnteriorLista(t,l);
}

/* ----------------------------------------------------------------------- */

char *CadenaLinea (Texto t, Linea l)
{
  return (char*)LeeNodoLista(t,l);
}

/* ----------------------------------------------------------------------- */

int InsertaLinea (Texto t, Linea l, char *s)
{
  char *aux = malloc(strlen(s)+1);

  if (aux) {

     strcpy(aux,s);

     if (InsertaNodoLista(t,l,aux)) {
	return 1;
     } else {
	free (aux);
	return 0;
     }

  } else
     return 0;
}

/* ----------------------------------------------------------------------- */

int AgregaLinea (Texto t, char *s)
{
  return InsertaLinea(t,FinTexto(t),s);
}

/* ----------------------------------------------------------------------- */

void BorraLinea (Texto t, Linea l)
{
  char *aux = LeeNodoLista(t,l);

  if (aux)
     free (aux);

  BorraNodoLista (t,l);
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

#define MAX_LINEA 256

Texto CargaTexto (char *fichero)
{
  Lista texto = NULL;
  int   posicion, aux, espacios;
  long  longitud;
  char  linea[MAX_LINEA];
  char *LineaTexto = NULL;
  FILE *fich = fopen(fichero,"r");

  if (fich) {

     texto = CreaLista (0);

     fseek (fich, 0, SEEK_END);
     longitud = ftell (fich);
     fseek (fich, 0, SEEK_SET);

     if (texto) {

	while (longitud!=ftell(fich)) {

	      fgets (linea, MAX_LINEA, fich);

	      if (strlen(linea)>0) {

		 for (posicion=0; posicion<strlen(linea); posicion++) {

		     if (linea[posicion]=='\n') {          /* Elimina '\n' */

			linea[posicion]='\0';

		     } else if (linea[posicion]=='\t') {    /* Expande '\t' */

			espacios = 8 - posicion%8;

			for (aux=strlen(linea); aux>posicion; aux--)
			    linea[aux+espacios-1] = linea[aux];

			for (aux=0; aux<espacios; aux++)
			    linea[posicion+aux] = ' ';
		     }
		 }

		 LineaTexto = malloc (strlen(linea)+1);

		 if (LineaTexto) {
		    strcpy (LineaTexto, linea);
		    InsertaNodoLista (texto, FinLista(texto), LineaTexto);
		 }
	      }
	}
     }

     fclose (fich);
  }

  return (texto);
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void GuardaTexto (Texto texto, char *fichero)
{
  Nodo  nodo = InicioLista(texto);
  FILE *fich = fopen (fichero, "w");

  if (fich) {

     while (nodo!=FinLista(texto)) {

	   fprintf (fich, "%s", (char*)LeeNodoLista(texto,nodo));

	   if (nodo!=UltimoLista(texto))
	      fprintf (fich, "\n");

	   nodo = SiguienteLista (texto, nodo);
     }

     fclose (fich);
  }
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
